// Aircraft.cpp: implementation of the CAircraft class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "atc.h"
#include "Aircraft.h"
#include <math.h>
#ifdef _DEBUG

#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////
#define TWOPI       (2 * 3.14159)
IMPLEMENT_SERIAL(CAircraft, CObject, 1)

CAircraft::CAircraft()
{
//int i;
m_nAltitude =m_nPitch =m_TrueCourse =0;
m_nCurrentDistance=0;
m_nPreviousDistance=0;
m_nSpeed=0;
m_nPosX=0;
m_nPosY=0;
m_nLeftRight=1;
m_nTimeDelta=0;
//m_nPrevPositionsCounter=0;
/*for(i=0;i<MAX_PREVIOUSPOSITIONS_PTS;i++)
	{

		m_ptPrevPositions[i].x=0;
		m_ptPrevPositions[i].y=0;
	}*/
}

CAircraft::~CAircraft()
{

}

int CAircraft::ComputeParameters()
{
	int nCode=0;	
//nt nCount1;
//nt nCount2;
//	double nStartCourse;
	m_nTimeDelta++;
	if(m_nTimeDelta==72000)
	{	
		m_bActive =FALSE; // 20 minutes
		nCode=3;
	}
	m_nPreviousDistance=m_nCurrentDistance;
	m_nCurrentDistance =  (double)(m_nSpeed/3600)+m_nPreviousDistance ;// vitesse/3600 s * 1 seconde
//	m_nPrevPositionsCounter==MAX_PREVIOUSPOSITIONS_PTS ? m_nPrevPositionsCounter=0:m_nPrevPositionsCounter++;
	m_nPrevPosX=m_nPosX;
	m_nPrevPosY=m_nPosY;
	m_nPosY=cos(TWOPI * m_TrueCourse/ 360)*(m_nSpeed/3600);
	m_nPosX=sin(TWOPI * m_TrueCourse/ 360)*(m_nSpeed/3600);
	m_nPosY=-m_nPosY;
	m_nPosX+=m_nPrevPosX;
	m_nPosY+=m_nPrevPosY;

	if(m_nStatus==STATUS_HOLD)
	{
		if (m_nSpeed!=m_nRequiredSpeed)
		{

			if(m_nRequiredSpeed>m_nSpeed)
			{
				m_nSpeed+=10;
			}
			else
			{
				m_nSpeed-=10;
			}
		}
		if(m_TrueCourse!=m_nRequiredTrueCourse )

			{	
			
				if( m_nLeftRight ==1)
				{
						m_TrueCourse--;
						if(m_TrueCourse==-1)m_TrueCourse=359;

				}
				else
				{

						m_TrueCourse++;
						if(m_TrueCourse==360)m_TrueCourse=0;

				}

			}
		if(m_nRequiredAltitude!=m_nAltitude)
		{
			if(m_nUpDown==0)
			{	
				
				m_nAltitude-=100;
				if(m_nRequiredAltitude>m_nAltitude)m_nRequiredAltitude=m_nAltitude;
			}
			else
			{
				m_nAltitude+=100;
				if(m_nRequiredAltitude<m_nAltitude)m_nRequiredAltitude=m_nAltitude;


			}
		}
	}//Status Hold
		else
	if(m_nStatus==STATUS_APPROACH)
	{
	//	if(m_nSpeed>0)m_nSpeed-=2;
		if(m_nAltitude>0)m_nAltitude-=50;
		if(m_nAltitude<=0)
		{
			m_bActive =FALSE;
			nCode=1;// attero 2:collision
		}

	}
	return nCode;
}

BOOL CAircraft::CheckForApproachEntryPoint(double nScaleFactor,POINT ptViewPortOrigin,double RunwayHeading,double wptX,double wptY,double MaxAltitude)
{
double distance;
//double altitude;
int DeltaAltitude;
//double DeltaCourse;
//	if(m_nStatus==STATUS_APPROACH)
//	{
double x=m_nPosX *nScaleFactor;
double y=m_nPosY *nScaleFactor;
x+=(double)ptViewPortOrigin.x ;
y+=(double)ptViewPortOrigin.y;		
		distance=CalcDistance(x, y,wptX,wptY);
		if(distance<100.00)
		{
			DeltaAltitude=abs(int(MaxAltitude-m_nAltitude ));
			if(DeltaAltitude<200)
			{
			//	DeltaCourse=abs(m_TrueCourse-RunwayHeading);
			//	if(DeltaCourse<15)
			//	{		
						m_nPosX=wptX;
						m_nPosY=wptY;
						m_nPosX-=(double)ptViewPortOrigin.x ;
						m_nPosY-=(double)ptViewPortOrigin.y ;
						m_nPosX/=nScaleFactor;
						m_nPosY/=nScaleFactor;
						m_nStatus=STATUS_APPROACH;	
						return TRUE;
						
			//	}
			}
		}


//	}
return FALSE;
}

double CAircraft::CalcDistance(double x1, double y1, double x2, double y2)
{
double delta_x;	
double delta_y;	
delta_x=(double)abs(x1-x2 );   
delta_y=(double)abs(y1-y2 );   
delta_x=delta_x*delta_x;
delta_y=delta_y*delta_y;
return((double)sqrt(delta_x+delta_y));
}

void CAircraft::Serialize(CArchive &ar)
{
CObject::Serialize( ar );
if(ar.IsStoring()) 
	{
		ar<<strATCName;
		ar<<m_bActive;
		ar<<m_bChangeParameters;
		ar<<m_nLeftRight;
		ar<<m_nUpDown;
		ar<<m_nStatus;
		ar<<m_nMaxSpeed;
		ar<<m_nMinSpeed;
		ar<<m_nRequiredSpeed;
		ar<<m_nRequiredTrueCourse;
		ar<<m_nRequiredAltitude;
		ar<<m_nSpeed;
		ar<<m_TrueCourse;
		ar<<m_nAltitude;
		ar<<m_nPitch;
		ar<<m_nPosX;
		ar<<m_nPosY;
		ar<<m_nPrevPosX;
		ar<<m_nPrevPosY;
		ar<<m_nPreviousDistance;
		ar<<m_nCurrentDistance;
	}
	else
	{
		ar>>strATCName;
		ar>>m_bActive;
		ar>>m_bChangeParameters;
		ar>>m_nLeftRight;
		ar>>m_nUpDown;
		ar>>m_nStatus;
		ar>>m_nMaxSpeed;
		ar>>m_nMinSpeed;
		ar>>m_nRequiredSpeed;
		ar>>m_nRequiredTrueCourse;
		ar>>m_nRequiredAltitude;
		ar>>m_nSpeed;
		ar>>m_TrueCourse;
		ar>>m_nAltitude;
		ar>>m_nPitch;
		ar>>m_nPosX;
		ar>>m_nPosY;
		ar>>m_nPrevPosX;
		ar>>m_nPrevPosY;
		ar>>m_nPreviousDistance;
		ar>>m_nCurrentDistance;
	
	}
}
