// Aircraft.h: interface for the CAircraft class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_AIRCRAFT_H__8B05F047_AD85_4EA5_BEA7_A19E2BBFFB70__INCLUDED_)
#define AFX_AIRCRAFT_H__8B05F047_AD85_4EA5_BEA7_A19E2BBFFB70__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CAircraft : public  CObject
{
public:
	void Serialize(CArchive& ar);
	double CalcDistance(double x1,double y1,double x2,double y2);
	BOOL CheckForApproachEntryPoint(double nScaleFactor,POINT ptViewPortOrigin,double RunwayHeading,double wptX,double wptY,double MaxAltitude);
	int ComputeParameters();
	CString strATCName;
	int m_nCAT;
	BOOL m_bActive;
	BOOL m_bChangeParameters;
	BOOL m_nLeftRight;
	
	int m_nUpDown;
	int m_nStatus;
	int m_nMaxSpeed;
	int m_nMinSpeed;
	double m_nTimeDelta;
	double m_nRequiredSpeed;
	double m_nRequiredTrueCourse;
	double m_nRequiredAltitude;
	double m_nSpeed;
	double m_TrueCourse;
	double m_nAltitude;
	double m_nPitch;
	double m_nPosX;
	double m_nPosY;
	double m_nPrevPosX;
	double m_nPrevPosY;
	double m_nPreviousDistance;
	double m_nCurrentDistance;
	CAircraft();
	virtual ~CAircraft();
DECLARE_SERIAL(CAircraft)
};

#endif // !defined(AFX_AIRCRAFT_H__8B05F047_AD85_4EA5_BEA7_A19E2BBFFB70__INCLUDED_)
