// atcDoc.cpp : implementation of the CAtcDoc class
//

#include "stdafx.h"
#include "atc.h"

#include "atcDoc.h"
#include "Options.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAtcDoc

IMPLEMENT_DYNCREATE(CAtcDoc, CDocument)

BEGIN_MESSAGE_MAP(CAtcDoc, CDocument)
	//{{AFX_MSG_MAP(CAtcDoc)
	ON_COMMAND(ID_FILE_NEW, OnMenuFileNewGame)
	ON_COMMAND(IDM_GAME_PAUSE, OnMenuGamePause)
	ON_UPDATE_COMMAND_UI(IDM_GAME_PAUSE, OnMenuUpdateGamePause)
	ON_COMMAND(IDM_OPTIONS, OnMenuOptions)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CAtcDoc construction/destruction

CAtcDoc::CAtcDoc()
{
	// TODO: add one-time construction code here
m_bGameActive=FALSE;m_bGenerateSlowPlanes=FALSE;m_bTutorial=FALSE;
}

CAtcDoc::~CAtcDoc()
{	
	ClearObjects();
}

BOOL CAtcDoc::OnNewDocument()
{
	if (!CDocument::OnNewDocument())
		return FALSE;
POINT pt;
pt.x =320;
pt.y =240;
strCurrentMessage="Start A New Game";
m_nAircraftGenerationInterval=120000;
m_bPause=FALSE;
ClearObjects();
	// TODO: add reinitialization code here
	// (SDI documents will reuse this document)
	m_runway.CalcPoints (pt,50);
	return TRUE;
}



/////////////////////////////////////////////////////////////////////////////
// CAtcDoc serialization

void CAtcDoc::Serialize(CArchive& ar)
{
	
	ClearObjects();
	if (ar.IsStoring())
	{
		// TODO: add storing code here
		ar<<strCurrentMessage;
		ar<<m_nActiveRunway ;
		ar<<m_nScaleFactor;
		ar<<m_nViewPortOrgX;
		ar<<m_nViewPortOrgY;

	}
	else
	{
		ar>>strCurrentMessage;
		ar>>m_nActiveRunway ;
		ar>>m_nScaleFactor;
		ar>>m_nViewPortOrgX;
		ar>>m_nViewPortOrgY;
	}
	m_ArrayAircrafts.Serialize (ar);
}

/////////////////////////////////////////////////////////////////////////////
// CAtcDoc diagnostics

#ifdef _DEBUG
void CAtcDoc::AssertValid() const
{
	CDocument::AssertValid();
}

void CAtcDoc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CAtcDoc commands

void CAtcDoc::OnMenuFileNewGame() 
{
	// TODO: Add your command handler code here
COptions dlg;
if(dlg.DoModal()==IDOK)
	InitAircrafts();
}

void CAtcDoc::ClearObjects()
{
int i;	
	m_nScore=0;
	for(i=0;i<m_ArrayAircrafts.GetSize();i++)
	{
		m_pCurrentAircraft=(CAircraft *)m_ArrayAircrafts.GetAt (i);
		delete m_pCurrentAircraft;
	}
		
	m_ArrayAircrafts.RemoveAll ();
}



void CAtcDoc::InitAircrafts()
{
double x,y;

strCurrentMessage="Start A New Game";
m_nActiveRunway=m_runway.m_nHeading ;
m_nScaleFactor=50;
m_nViewPortOrgX=320;
m_nViewPortOrgY=240;

m_bGameActive =TRUE;

m_nSelectedAircraftIndex=0;
GenerateNewAicrafts();
/*
m_pCurrentAircraft =new CAircraft();
m_pCurrentAircraft->m_bActive=TRUE;
m_pCurrentAircraft->m_nUpDown=0;
m_pCurrentAircraft->m_nRequiredSpeed =m_pCurrentAircraft->m_nSpeed =150;
m_pCurrentAircraft->m_nRequiredTrueCourse =m_pCurrentAircraft->m_TrueCourse =10;
m_pCurrentAircraft->m_nRequiredAltitude= m_pCurrentAircraft->m_nAltitude=5000;
m_pCurrentAircraft->strATCName="AF 2120";
m_pCurrentAircraft->m_nStatus =STATUS_HOLD;
m_pCurrentAircraft->m_nMaxSpeed=250;// Dash !!
m_pCurrentAircraft->m_nMinSpeed=100;
m_ArrayAircrafts.Add (m_pCurrentAircraft);

m_pCurrentAircraft =new CAircraft();
m_pCurrentAircraft->m_bActive=FALSE;
m_pCurrentAircraft->m_nUpDown=0;
m_pCurrentAircraft->m_nRequiredSpeed =m_pCurrentAircraft->m_nSpeed =250;
m_pCurrentAircraft->m_nRequiredTrueCourse =m_pCurrentAircraft->m_TrueCourse =180;
m_pCurrentAircraft->m_nRequiredAltitude= m_pCurrentAircraft->m_nAltitude=8000;
m_pCurrentAircraft->strATCName="DELTA 100";

m_pCurrentAircraft->m_nStatus =STATUS_HOLD;


m_pCurrentAircraft->m_nMaxSpeed=450;// Dash !!
m_pCurrentAircraft->m_nMinSpeed=150;
m_ArrayAircrafts.Add (m_pCurrentAircraft);

m_pCurrentAircraft =new CAircraft();
m_pCurrentAircraft->m_bActive=FALSE;
m_pCurrentAircraft->m_nUpDown=0;
m_pCurrentAircraft->m_nRequiredSpeed =m_pCurrentAircraft->m_nSpeed =50;
m_pCurrentAircraft->m_nRequiredTrueCourse =m_pCurrentAircraft->m_TrueCourse =45;
m_pCurrentAircraft->m_nRequiredAltitude= m_pCurrentAircraft->m_nAltitude=5000;
m_pCurrentAircraft->strATCName="CESSNA 10";

m_pCurrentAircraft->m_nStatus =STATUS_HOLD;


m_pCurrentAircraft->m_nMaxSpeed=130;// Dash !!
m_pCurrentAircraft->m_nMinSpeed=80;
m_ArrayAircrafts.Add (m_pCurrentAircraft);


m_pCurrentAircraft =new CAircraft();
m_pCurrentAircraft->m_bActive=FALSE;
m_pCurrentAircraft->m_nUpDown=0;
m_pCurrentAircraft->m_nRequiredSpeed =m_pCurrentAircraft->m_nSpeed =400;
m_pCurrentAircraft->m_nRequiredTrueCourse =m_pCurrentAircraft->m_TrueCourse =180;
m_pCurrentAircraft->m_nRequiredAltitude= m_pCurrentAircraft->m_nAltitude=10000;
m_pCurrentAircraft->strATCName="KLM747";

m_pCurrentAircraft->m_nStatus =STATUS_HOLD;


m_pCurrentAircraft->m_nMaxSpeed=450;// 747
m_pCurrentAircraft->m_nMinSpeed=159;
m_ArrayAircrafts.Add (m_pCurrentAircraft);*/


}

void CAtcDoc::OnMenuGamePause() 
{
	m_bPause ==TRUE ? m_bPause=FALSE:m_bPause=TRUE;	strCurrentMessage="Game Paused";

}

void CAtcDoc::OnMenuUpdateGamePause(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
		m_bPause==TRUE ? pCmdUI->SetCheck (1) : 	pCmdUI->SetCheck (0) ;

}

void CAtcDoc::CheckAircraftsCollision()
{
	int i;
	CAircraft *pAircraft;
	for(i=0;i<m_ArrayAircrafts.GetUpperBound()+1;i++)
				{

				//	pAircraft  =(CAircraft *)m_ArrayAircrafts.GetAt(i);
				//	if(pAircraft->m_bActive ==TRUE)
				//	pAircraft->ComputeParameters();
				}
}

void CAtcDoc::OnMenuOptions() 
{
COptions dlg;
dlg.DoModal();	
}

void CAtcDoc::GenerateNewAicrafts()
{
	char *CAT1[]={"Cessna 1","Beech 1","Cessna 2", "Beech 2"};
	char *CAT2[]={"Mid 1","Regional 1","Mid 2", "Regional 2"};
	char *CAT3[]={"KLM 200","AF 1210","BA 250", "AZ 3000"};


int n;	
if(m_bGameActive ==FALSE)return;
m_pCurrentAircraft =new CAircraft();
m_pCurrentAircraft->m_bActive=TRUE;
m_pCurrentAircraft->m_nUpDown=0;
n=rand()%3;
if(n==3)n=2;
	if(m_bGenerateSlowPlanes==FALSE) 
	{

		if(n==0) n=2;
	}
switch(n)
{	
	case 0:
		m_pCurrentAircraft->m_nRequiredSpeed=m_pCurrentAircraft->m_nSpeed =	m_pCurrentAircraft->m_nMaxSpeed=150;
		m_pCurrentAircraft->m_nRequiredAltitude= m_pCurrentAircraft->m_nAltitude=5000;

			m_pCurrentAircraft->m_nMinSpeed=80;
			m_pCurrentAircraft->m_nCAT=1;
			n=rand()%3;
			m_pCurrentAircraft->strATCName =CAT1[n];
	break;

	case 1:
		m_pCurrentAircraft->m_nRequiredSpeed=m_pCurrentAircraft->m_nSpeed =	m_pCurrentAircraft->m_nMaxSpeed=250;
		m_pCurrentAircraft->m_nRequiredAltitude= m_pCurrentAircraft->m_nAltitude=10000;

			m_pCurrentAircraft->m_nMinSpeed=100;
			m_pCurrentAircraft->m_nCAT=2;
			n=rand()%3;
			m_pCurrentAircraft->strATCName =CAT2[n];
	break;

	case 2:
		m_pCurrentAircraft->m_nRequiredSpeed=m_pCurrentAircraft->m_nSpeed =	m_pCurrentAircraft->m_nMaxSpeed=450;
		m_pCurrentAircraft->m_nRequiredAltitude= m_pCurrentAircraft->m_nAltitude=15000;
			m_pCurrentAircraft->m_nMinSpeed=150;
			m_pCurrentAircraft->m_nCAT=3;
			n=rand()%3;
			m_pCurrentAircraft->strATCName =CAT3[n];

	break;


}


m_pCurrentAircraft->m_nStatus =STATUS_HOLD;

n=rand()%359;

m_pCurrentAircraft->m_nRequiredTrueCourse =m_pCurrentAircraft->m_TrueCourse =n;

m_ArrayAircrafts.Add (m_pCurrentAircraft);	
	
	

/*	CAircraft *pAircraft;
	int i;
	for(i=0;i<m_ArrayAircrafts.GetUpperBound()+1;i++)
	{
		pAircraft  =(CAircraft *)m_ArrayAircrafts.GetAt(i);
		if(pAircraft->m_bActive ==FALSE)
		{
			pAircraft->m_bActive=TRUE;
			break;
		}

	}*/
}
