// atcDoc.h : interface of the CAtcDoc class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_ATCDOC_H__A5B5BBB4_1562_4A6D_8875_42A7F9E84657__INCLUDED_)
#define AFX_ATCDOC_H__A5B5BBB4_1562_4A6D_8875_42A7F9E84657__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Aircraft.h"
#include "Runway.h"
class CAtcDoc : public CDocument
{
protected: // create from serialization only
	CAtcDoc();
	DECLARE_DYNCREATE(CAtcDoc)

// Attributes
public:
	BOOL m_bPause;
	BOOL m_bGameActive;
	BOOL m_bTutorial;
	BOOL m_bGenerateSlowPlanes;
	double m_nActiveRunway;
	long m_nAircraftGenerationInterval;
	int m_nViewPortOrgX;
	int m_nViewPortOrgY;
	int m_nScaleFactor;
	int m_nScore;
	int m_nSelectedAircraftIndex;
	CString strCurrentMessage;
	CObArray m_ArrayAircrafts;
	CAircraft *m_pCurrentAircraft;
	CRunway m_runway;
// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAtcDoc)
	public:
	virtual BOOL OnNewDocument();
	virtual void Serialize(CArchive& ar);
	//}}AFX_VIRTUAL

// Implementation
public:
	void GenerateNewAicrafts();
	void CheckAircraftsCollision();
	void InitAircrafts();
	void ClearObjects();
	virtual ~CAtcDoc();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	//{{AFX_MSG(CAtcDoc)
	afx_msg void OnMenuFileNewGame();
	afx_msg void OnMenuGamePause();
	afx_msg void OnMenuUpdateGamePause(CCmdUI* pCmdUI);
	afx_msg void OnMenuOptions();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_ATCDOC_H__A5B5BBB4_1562_4A6D_8875_42A7F9E84657__INCLUDED_)
