// atcView.cpp : implementation of the CAtcView class
//

#include "stdafx.h"
#include "atc.h"

#include "atcDoc.h"
#include "atcView.h"
#include <math.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define ID_TIMER1 1
/////////////////////////////////////////////////////////////////////////////
// CAtcView

IMPLEMENT_DYNCREATE(CAtcView, CView)

BEGIN_MESSAGE_MAP(CAtcView, CView)
	//{{AFX_MSG_MAP(CAtcView)
	ON_WM_TIMER()
	ON_WM_CREATE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CAtcView construction/destruction

CAtcView::CAtcView()
{
	// TODO: add construction code here
/*	m_nScaleFactor=100;
	m_nViewPortOrgX=320;
	m_nViewPortOrgY=240;*/
	m_nTimerInterval=0;
}

CAtcView::~CAtcView()
{
//	KillTimer(ID_TIMER1);
}

BOOL CAtcView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs
//	SetTimer (ID_TIMER1, 1000, NULL);
	return CView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CAtcView drawing

void CAtcView::OnDraw(CDC* pDC)
{
	CAtcDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	CheckForApproachThreshold(pDC);
	DisplayAircrafts(pDC);
	pDoc->m_runway.Draw (pDC); 
	ShowInfos(pDC);
}

/////////////////////////////////////////////////////////////////////////////
// CAtcView diagnostics

#ifdef _DEBUG
void CAtcView::AssertValid() const
{
	CView::AssertValid();
}

void CAtcView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CAtcDoc* CAtcView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CAtcDoc)));
	return (CAtcDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CAtcView message handlers

void CAtcView::DisplayAircrafts(CDC *dc)
{
//CString str;
	CAtcDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
CPoint pt;	
CRect rect;
CString strVal;
CAircraft *pAircraft;
//CBrush brush;	
//CBrush *pOldBrush;
int i;
double x;
double y;
for(i=0;i<pDoc->m_ArrayAircrafts.GetUpperBound()+1;i++)
	{
		pAircraft  =(CAircraft *)pDoc->m_ArrayAircrafts.GetAt(i);
		if(pAircraft->m_bActive ==TRUE)
		{
				x=pAircraft->m_nPosX *pDoc->m_nScaleFactor;
				y=pAircraft->m_nPosY *pDoc->m_nScaleFactor;
				x+=pDoc->m_nViewPortOrgX;
				y+=pDoc->m_nViewPortOrgY;
				pt.x =int(x);
				pt.y =int(y);	

				rect.left =pt.x ;
				rect.top =pt.y ;
			//	rect.right =pt.x +(pDoc->m_nScaleFactor/5);
			//	rect.bottom =pt.y +(pDoc->m_nScaleFactor/5);
				rect.right =pt.x +10;
				rect.bottom =pt.y +10;
				dc->Rectangle (rect);
				dc->SelectStockObject (DEFAULT_GUI_FONT);
				if(pDoc->m_nSelectedAircraftIndex !=i)
				dc->SetTextColor (RGB(0,255,0));
				else 
				dc->SetTextColor (RGB(0,0,0));
				dc->TextOut (pt.x ,pt.y-50,pAircraft->strATCName);
				strVal.Format ("%.1f",pAircraft->m_TrueCourse);
				strVal=strVal+ "";
				dc->TextOut (pt.x ,pt.y-35,strVal);
				strVal.Format ("%.1f",pAircraft->m_nAltitude);
				strVal=strVal+ "ft";
				dc->TextOut (pt.x ,pt.y-20,strVal);
				strVal.Format ("%.1f",pAircraft->m_nSpeed);
				strVal=strVal+ "kts";
				dc->TextOut (pt.x ,pt.y-5,strVal);
		}
	}
}

void CAtcView::OnTimer(UINT nIDEvent) 
{
	// TODO: Add your message handler code here and/or call default
	CAircraft *pAircraft;
	CAtcDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	int nRetCode;
	long l;
	int i;
	switch(nIDEvent)
	{
		case ID_TIMER1:
			
			if(pDoc->m_bPause ==FALSE)
				{
				if(pDoc->m_bTutorial ==FALSE)
					{
						m_nTimerInterval++;
						l=m_nTimerInterval*60;
						if(m_nTimerInterval*1000>=pDoc->m_nAircraftGenerationInterval){
							m_nTimerInterval=0;

							pDoc->GenerateNewAicrafts();
					}
				
				} 
				
				for(i=0;i<pDoc->m_ArrayAircrafts.GetUpperBound()+1;i++)
				{
				//	pDoc->m_pCurrentAircraft  =(CAircraft *)pDoc->m_ArrayAircrafts.GetAt(i);
				//	pDoc->m_pCurrentAircraft->ComputeParameters();
					pAircraft  =(CAircraft *)pDoc->m_ArrayAircrafts.GetAt(i);
					if(pAircraft->m_bActive ==TRUE)
					{
					nRetCode=	pAircraft->ComputeParameters();
					if(nRetCode==3)pDoc->strCurrentMessage="Approach Time Too Long For....";

					if(nRetCode==1) 
						
					{	
						if(pAircraft->m_nTimeDelta<=18000)
						{
						// 5 minutes
							pDoc->m_nScore +=400;

						}

						
						if(pAircraft->m_nTimeDelta<=25200)
						{
						// 7 minutes
							pDoc->m_nScore +=300;

						}



						if(pAircraft->m_nTimeDelta<=36000)
						{
						// 10 minutes
							pDoc->m_nScore +=200;

						}
						
						if(pAircraft->m_nTimeDelta<=43200)
						{
						// 10 minutes
							pDoc->m_nScore +=100;

						}
						//	TODO faire removeAt
					}

					/*	pAircraft->m_nTimeDelta++;
						if(pAircraft->m_nTimeDelta>=72000)
						{
							pAircraft->m_bActive =FALSE;
							pDoc->strCurrentMessage="Approach Time Too Long For....";
						}
						if(pAircraft->m_nStatus==STATUS_APPROACH)*/
					
					}
				}
			}
			Invalidate();
		break;

	}
	CView::OnTimer(nIDEvent);
}

int CAtcView::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CView::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	// TODO: Add your specialized creation code here
SetTimer (ID_TIMER1, 1000, NULL);	
	return 0;
}

BOOL CAtcView::DestroyWindow() 
{
	// TODO: Add your specialized code here and/or call the base class
	KillTimer(ID_TIMER1);
	return CView::DestroyWindow();
}





void CAtcView::ShowInfos(CDC *dc)
{
	CAtcDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	
	CRect rect;
	CString strInfo;
	CString strInfo2;
	GetClientRect(rect);
	dc->Rectangle (0,0,rect.Width()/2,20);
	strInfo="Runway 3 ";
	dc->SelectStockObject (DEFAULT_GUI_FONT);

	dc->TextOut (rect.left+10,5,strInfo);


	dc->Rectangle (rect.Width()/2,0,rect.Width(),20);
	strInfo="Runway 3 ";
	dc->Rectangle (0,rect.Height()-20,rect.Width()/2,rect.Height());

	dc->SelectStockObject (DEFAULT_GUI_FONT);

	dc->TextOut (rect.Width()/2+5,5,pDoc->strCurrentMessage);
	strInfo2.Format("%i",pDoc->m_nScore);
	strInfo="Score:" +strInfo2 ;
	dc->TextOut (5,rect.Height()-15,strInfo);
}

void CAtcView::CheckForApproachThreshold(CDC *dc)
{
	int i;
	CAircraft *pAircraft;
	CAtcDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	double distance;
	int DeltaAltitude;
//	BOOL b;
//	POINT pt;
	POINT ptCircle;
	CRect rect;
	double x;
	double y;
//	pt.x=pDoc->m_nViewPortOrgX;
//	pt.y=pDoc->m_nViewPortOrgY;
	ptCircle.x =pDoc->m_runway.m_points[2].x ;
	ptCircle.y =pDoc->m_runway.m_points[2].y ;
	rect.left =ptCircle.x-50;
	rect.top  =ptCircle.y-50;
	rect.right =ptCircle.x +50;
	rect.bottom =ptCircle.y +50;
	for(i=0;i<pDoc->m_ArrayAircrafts.GetUpperBound()+1;i++)
	{
		pAircraft  =(CAircraft *)pDoc->m_ArrayAircrafts.GetAt(i);
		if(pAircraft->m_bActive ==TRUE)
		{
		//	b=pDoc->m_pCurrentAircraft->CheckForApproachEntryPoint(pDoc->m_nScaleFactor ,pt,pDoc->m_nActiveRunway,pDoc->m_runway.m_points[2].x , 
		//											 pDoc->m_runway.m_points[2].y ,2000);


			x=pAircraft->m_nPosX *pDoc->m_nScaleFactor ;
			y=pAircraft->m_nPosY *pDoc->m_nScaleFactor ;
			x+=(double)pDoc->m_nViewPortOrgX ;
			y+=(double)pDoc->m_nViewPortOrgY;		
			distance=CalcDistance(x, y,pDoc->m_runway.m_points[2].x,pDoc->m_runway.m_points[2].y);
				if(distance<100.00)
				{		
						
						DeltaAltitude=abs(int(pAircraft->m_nAltitude-2000 ));
						if(DeltaAltitude<200)
						{
							dc->Ellipse (&rect);
						}

				}
		}
	}
}

double CAtcView::CalcDistance(double x1, double y1, double x2, double y2)
{
double delta_x;	
double delta_y;	
delta_x=(double)abs(x1-x2 );   
delta_y=(double)abs(y1-y2 );   
delta_x=delta_x*delta_x;
delta_y=delta_y*delta_y;
return((double)sqrt(delta_x+delta_y));
}
